#/usr/bin/perl 
use POSIX;

open GL2E, ">gismuL2E.tab";
open GE2L, ">gismuE2L.tab";
my %dict;
while(<>)
#read in all gismu and keywords
{
($gismu, $rafsi1, $rafsi2, $rafsi3, $gloss) = 
        m/^(.{5}) \s (.{3} \s) (.{3} \s) (.{4} \s) (\S+(\s\S+)*) /x and  do
        {
        	($gloss) = $gloss =~ m/^\s* (\S .*) $/x;
        	$dict{$gismu} = $gloss;
        }
}

seek STDIN, 0, 0;
#from the top!
$intro=<>;
chomp $intro;
$intro .= "<br>Converted by Nick Nicholas, nicholas\@uci.edu, " .
    POSIX::strftime("%Y-%m-%d", gmtime(time)) .
    ".<br>.i te galfi fi tu'a la nik. NIkolas. (goi nitcion.) noi se samymrilyjudri \"zoixy. nicholas\@uci.edu \"xy. de'i li " .
    POSIX::strftime("%Ypi'e%mpi'e%d", gmtime(time)) .
    "<hr><b>Lojban<b> - the Logical Language<br>la lojban. po'u le logji bangu<br>http:\/\/www.lojban.org";
print GE2L " INFO\t$intro\n";
print GL2E " INFO\t$intro\n";
while(<>)
{
    ($gismu, $rafsi1, $rafsi2, $rafsi3, $gloss) = 
        m/^(.{5}) \s (.{3} \s) (.{3} \s) (.{4} \s) (\S+(\s\S+)*) /x and  do
        {
            $entry = $';
            ($gloss) = $gloss =~ m/^\s* (\S .*) $/x;
            ($rafsi1) = $rafsi1 =~ m/^\s* (\S+) \s* $/x;
            ($rafsi2) = $rafsi2 =~ m/^\s* (\S+) \s* $/x;
            ($rafsi3) = $rafsi3 =~ m/^\s* (\S+) \s* $/x;
            if (($quot) = $entry =~ m/(\s{3} '[^']+' \s)/x) 
             # The space to guarantee these are not Lojban excls
             # The large initial space that this is not a mid-entry space
            {    
                $quot = $` . $quot;
                $entry = $';
                ($quot) = $quot =~ m/^\s* (\S .*) $/x;                   
            };
            ($entry) = $entry =~ m/^\s* (\S .*) $/x;
            if ( ($cf) = $entry =~ m/( \( cf. .* \) )/x )
            {
                $pre = $`;
                $post = $';
                $engcf = $cf;
                $cf =~ s/(\W) (\w{5}) (\W)/$1<a:$2 = $dict{$2}>$2<\/a>$3/xg;
                $engcf =~ s/(\W) (\w{5}) (\W)/$1<a:$dict{$2} = $2>$2<\/a>$3/xg;
                $linkedentry = $pre . $cf . $post;
                $englinkedentry  = $pre . $engcf . $post;
            }
            else
            {
            	$englinkedentry = $linkedentry = $entry;
            }
            print GE2L "$gloss = $gismu\t<b>$gismu</b> <i>";
            print GE2L "$rafsi1 " if $rafsi1;
            print GE2L "$rafsi2 " if $rafsi2;
            print GE2L "$rafsi3" if $rafsi3;
            print GE2L " </i>$quot<br>$englinkedentry\n" ;
            
            print GL2E "$gismu = $gloss\t<b>$gloss</b> <i>(";
            print GL2E "$rafsi1 " if $rafsi1;
            print GL2E "$rafsi2 " if $rafsi2;
            print GL2E "$rafsi3" if $rafsi3;
            print GL2E ") </i>$quot<br>$linkedentry\n" ;
        }
        or print STDERR $_  ;
}

=pod
    ($gismu, $rafsi1, $rafsi2, $rafsi3, $gloss, $entry, $cf) = 
        m/^(.{6}) \s (.{3} \s) (.{3} \s) (.{4} \s) (\w+) \s (.*) (\( cf. .* \))? $/x and
            print "$gloss\t$gismu\t$rafsi1\t$rafsi2\t$rafsi3\t$entry\t$cf\n"
        or print STDERR $_
=cut
